#!/usr/bin/python

from Tkinter import *

def moveit():
  global w, h, r
  global x, y, vx, vy, gam, t
  global flag
  x=x+vx*dt
  vy=vy+gam*dt
  y=y+vy*dt
  if(y>h):
    y=h
    vy=-vy
  if(y<0):
    y=0
    vy=-vy
  if(x>w):
    x=w
    vx=-vx
  if(x<0):
    x=0
    vx=-vx
  c.coords(b,x, y, x+2*r, y+2*r)
  if flag == 1:
    m.after(int(100*dt), moveit)

def start_it():
  global flag
  if flag == 0:
    flag=1
    moveit()

def stop_it():
  global flag
  flag = 0

w=300
h=200
r=10
x=0
y=0
vx=10
vy=0
dt=.1
gam=10
flag=0

m=Tk()

c=Canvas(m, height=r+h, width=r+w)
m.title("Bounce")
m.geometry("+100+100")
c.pack()

t=Toplevel(m)
t.configure(bg="SlateGray4")

t.geometry("+450+150")
t.title("Control")

b1=Button(t, text="Start", bg="SlateGray4", command=start_it)
b1.pack()
b2=Button(t, text="Stop", bg="SlateGray4", command=stop_it)
b2.pack()
b3=Button(t, text="Quit", bg="SlateGray4", command=m.quit)
b3.pack()

b=c.create_oval( x, y, x+2*r, y+2*r, fill="OrangeRed")

m.mainloop()
