#!/usr/bin/python

from Tkinter import *
import time

n=6
m=Tk()
h=200.
w=300.
c=Canvas(m,height=h, width=w)
c.pack()
running=0

class palet:
  def __init__(self, width, height, x, y):
    self.width=width
    self.height=height
    self.x1=x-self.width/2.
    self.x2=self.x1+width
    self.y1=h-y
    self.y2=self.y1+height
    self.p=c.create_rectangle(self.x1,self.y1,self.x2,self.y2)
    c.itemconfigure(self.p,fill='blue')
  def move(self,x,y):
    self.x1=x-self.width/2.
    self.x2=self.x1+self.width
    self.y1=h-y
    self.y2=self.y1+self.height
    c.coords(self.p,self.x1,self.y1,self.x2,self.y2)

class stack:
  def __init__(self, n, x):
    self.s=[]
    self.x=x
    if n != 0:
      y=5.
      w=80.
      for i in range(0,n):
        self.s.append(palet(w,10.,self.x,y))
        y+=15.
        w-=(80.-20.)/(n-1.)
    c.create_rectangle(x-2.,h+5., x+2.,50.,fill='red')
  def pop(self):
    return self.s.pop()
  def push(self, p):
    p.move(self.x, 5.+15.*len(self.s))
    self.s.append(p)

s=[]
s.append(stack(n, 50. ))
s.append(stack(0, 150.))
s.append(stack(0, 250.))

def hanoi(n,i,j):
  if n == 0: return
  k=3-i-j
  hanoi(n-1,i,k)
  if running==1: time.sleep(.5)
  else: m.destroy()
  s[j].push(s[i].pop())
  m.update()
  hanoi(n-1,k,j)

def solve():
  global running
  running=1
  hanoi(n,0,2)

def stop():
  global running
  running=0

b1=Button(m, text="Go!", command=solve)
b1.pack()
b2=Button(m, text="Stop!", command=stop)
b2.pack()

m.mainloop()
