#!/usr/bin/python

import socket, sys, threading

SOL_SOCKET=0xffff
SO_REUSEADDR=0x0004

HOST = '0.0.0.0'
PORT = 1234

class Server (threading.Thread):
  def __init__(self, c,add):
    threading.Thread.__init__(self)
    self.c=c
    self.add=add
  def run(self):
    while 1:
      self.c.send("S>")
      mc = self.c.recv(1024).strip("\n\r\l")
      print "C", self.add[0],":",self.add[1],">",mc
      if mc.upper() == "FIN":
        break
    self.c.send("Bye...")
    self.c.close()
    

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.setsockopt(SOL_SOCKET, SO_REUSEADDR,1)
try:
  s.bind((HOST, PORT))
except socket.error:
  print "bind error"
  sys,exit(-1)
s.listen(5)
while 1:
  c, add = s.accept()
  print "connexion de %s:%s" % (add[0], add[1])
  th=Server(c,add)
  th.start()
