#!/usr/bin/python

import sys

nsol=0
grid=[]

def read_grid( file ):
  f=open(file,"r")
  for l in range(0,9):
    grid.append([])
    line=f.readline()
    for c in range(0,9):
      grid[l].append(line[c])

def print_one():
  global nsol
  nsol +=1
  print "solution %d" % (nsol)
  for l in range(0,9):
    for c in range(0,9):
      print grid[l][c],
    print    

def test(i,j,n):
  if grid[i][j] == n: return True
  if grid[i][j] != '-': return False
  for c in range(0,9):
    if grid[i][c] == n: return False
  for l in range(0,9):
    if grid[l][j] == n: return False
  bl=int(i/3)
  bc=int(j/3)
  for l in range(bl*3,(bl+1)*3):
    for c in range(bc*3,(bc+1)*3):
      if grid[l][c] == n: return False
  return True
  
def solve(l,c):
  global grid
#  print "|","-"*(9*l+c)
#  print 9*l+c
  if l == 9: print_one()
  else:
    for n in range(1,10):
      n=str(n)
      if test(l,c,n):
        t=grid[l][c]
        grid[l][c]=n
        if c == 8: solve(l+1,0)
        else: solve(l,c+1)
        grid[l][c]=t

if __name__ == "__main__":
  if len(sys.argv) !=2:
    print "usage: %s grid_file" % (sys.argv[0])
    sys.exit(-1)
  read_grid( sys.argv[1] )
  solve(0,0)
