#!/usr/bin/env python

import urllib
import urllib2

def queryTauCSO(date, hstart='00:00', hend='23:59'):

    yy,mm,dd = date.split('-')
    sh,sm = hstart.split(':')
    eh,em = hend.split(':')
    print "Request: %s-%s-%s from %s:%s to %s:%s" % (yy,mm,dd,sh,sm,eh,em)

    url = 'http://ulu.submm.caltech.edu/csotau/2tau.pl'
    data = urllib.urlencode({
            'tboxbl1':mm,
            'tboxbl2':dd,
            'tboxbl3':yy,
            'tboxbl4':sh,
            'tboxbl5':sm,
            'tboxbl6':eh,
            'tboxbl7':em,
            'Submit':'Submit',
            })
    print "Data:",data

    #req = url+'?'+data          # GET
    req = urllib2.Request(url, data) # POST
    response = urllib2.urlopen(req)
    print response.read()

if __name__=='__main__':

    date='2008-04-01'           # YYYY-MM-DD
    hstart='12:34'              # HH:MM (GMT)
    hend='13:57'                # HH:MM (GMT)

    queryTauCSO(date, hstart=hstart, hend=hend)

