#!/usr/bin/python

from Tkinter import *
from math import sin, cos
import time, threading

class App(Frame):
  def __init__(self):
    Frame.__init__(self)
    self.pack()
    c=Canvas(self, width=400, height=400,
             bg='ivory', bd=3, relief=SUNKEN)
    c.pack(padx=5, pady=5)
    ce=c.create_oval(185, 355, 215, 385, fill = 'red')
    tb=Thread_balle(c, ce)
    Button(self, text='Marche', command=tb.start).pack(side=LEFT)
    self.bind('<Destroy>', tb.stop)

class Thread_balle(threading.Thread):
  def __init__(self, c, de):
    threading.Thread.__init__(self)
    self.c, self.de = c, de
    self.anim=1
  def run(self):
    a=0.0
    while self.anim==1:
      a += 0.01
      x, y = 200+170*sin(a), 200+170*cos(a)
      self.c.coords(self.de, x-15, y-15, x+15, y+15)
      time.sleep(0.01)
  def stop(self, evt=0):
    self.anim=0

App().mainloop()
