#!/usr/bin/python

import sys
from Tkinter import *
import time

r=Tk()
g=[]
a=[]
b=[]

def solve():
  solve_grid(0,0)

def read_grid(f):
  global g
  f=open(f,'r')
  j=0
  for l in f:
    g.append([])
    b.append([])
    a.append(Frame(r))
    a[j].pack(side='top')
    for i in range(0,9):
      g[j].append(l[i])
      b[j].append(Label(a[j],width=2,height=1,text=l[i],relief='sunken'))
      b[j][i].pack(side='left')
      if l[i] != '-':b[j][i].config(fg='blue')
      else:b[j][i].config(fg='red')
    j=j+1
  s=Button(r,text='Start',command=solve)
  s.pack(side='top')

def print_grid():
  global g
  for i in range(0,9):
    for j in range(0,9):
      print g[i][j],
    print

def test_grid(a,l,c):
  global g
#  print a,l,c,g[l][c]
  if g[l][c] == a: return True
  if g[l][c] != '-':return False
  for i in range(0,9):
    if a == g[l][i]: return False
  for i in range(0,9):
    if a == g[i][c]: return False
  for i in range(0,3):
    for j in range(0,3):
      if g[i+3*(l/3)][j+3*(c/3)] == a:return False
  return True

def solve_grid(l,c):
  global g
  if l == 9:
    print_grid()
    time.sleep(10)
    sys.exit()
  else:
    for n in range(1,10):
      n=str(n)
      if test_grid(n,l,c):
        m=g[l][c]
        b[l][c].config(text=n)
        r.update()
        g[l][c]=n
        if c == 8:
          solve_grid(l+1,0)
        else:
          solve_grid(l,c+1)
        g[l][c]=m
        b[l][c].config(text=m)
        r.update()

if len(sys.argv) != 2:
  print "usage:", sys.argv[0], "file"
  sys.exit()
read_grid(sys.argv[1])
r.mainloop()
#solve_grid(0,0)
